/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Horario(){
	this.x=100;
	this.y=50;
	this.dias=7;
	this.hora_inicial=9;
	this.hora_final=23;
	this.horas_por_dia=this.hora_final-this.hora_inicial;
	
	this.celda_w=75;
	this.celda_h=25;
	
	this.celdas=new Array(this.dias);
	var i;
	for(i=0;i<this.dias;i++){
		this.celdas[i]=new Array(this.horas_por_dia);
		var j;
		for(j=0;j<this.horas_por_dia;j++)
			this.celdas[i][j]=0;
	}
	
	this.nombres=new Array({{ bandas|length }}+1);
	var id_banda=1;
	var y=160;
	this.nombres[0]=new Texto("Libre",ANCHURA_VENTANA-30,y,200,25,AL_IZQ)
	{% for banda in bandas %}
		y+=30;
		this.nombres[id_banda]=new Texto("{{ banda.name }}",ANCHURA_VENTANA-30,y,200,25,AL_IZQ);
		id_banda++;
	{% endfor %}

	{% for bt in bands_timetable %}
		id_banda=1;
		while(id_banda<this.nombres.length && this.nombres[id_banda].obtener_texto()!="{{ bt.band.name }}")
			id_banda++;
		var dia={{ bt.dia }};
		var hora;
		for(hora={{ bt.hora_inicio }};hora<{{ bt.hora_fin }};hora++)
			this.celdas[dia][hora-this.hora_inicial]=id_banda;
	{% endfor %}
	
	this.dia_destacado=-1;
	this.hora_destacada=-1;
	
	this.dia_nuevo=-1;
	this.hora_inicio_destacada=-1;
	this.hora_fin_destacada=-1;
	
	this.banda_destacada=-1;
	
	this.destacar_celdas=function(x,y){
		this.dia_destacado=-1;
		this.hora_destacada=-1;
		var i,j;
		var x_celda=this.x;
		var y_celda;
		for(i=0;i<this.celdas.length && this.dia_destacado==-1;i++){
			y_celda=this.y;
			for(j=0;j<this.celdas[i].length && this.dia_destacado==-1;j++){
				var x1=x_celda;
				var y1=y_celda;
				var x2=x1+this.celda_w;
				var y2=y1+this.celda_h;

				if(x>=x1 && x<=x2 && y>=y1 && y<=y2){
					this.dia_destacado=i;
					this.hora_destacada=j;
				}
					
				y_celda+=this.celda_h;
			}
			x_celda+=this.celda_w;
		}			
	}
	
	this.destacar_bandas=function(x,y){
		this.banda_destacada=-1;
		var i;
		var y1=140;
		var x1=ANCHURA_VENTANA-160;
		var x2=x1+100;
		for(i=0;i<this.nombres.length && this.banda_destacada==-1;i++){
			var y2=y1+20;

			if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
				this.banda_destacada=i;

			y1+=30;
		}			
	}
}

function Dialogo(x,y,w,h,tag){
	
	this.tag=tag;
	if(tag!=-1){
		this.x=x;
		this.y=y;
		this.w=w;
		this.h=h;
		this.alpha=0.0;
		this.opcion_apuntada=-1;
		
		if(tag==TAG_BORRAR_HORARIO){
			this.opcion_w=100;
			this.opcion_h=50;
			this.coordenadas_opciones=repartir_elementos(x+w/2,y+h-h/3,2,2,this.opcion_w,this.opcion_h,50);
			this.texto_opciones=new Array();
			this.texto_opciones[0]="Eliminar";
			this.texto_opciones[1]="Cancelar";
			this.texto=new Texto("Eliminar las horas de ensayo?",x+w/2,y+25,w-50,30,AL_IZQ);
		}else if(tag==TAG_NUEVO_HORARIO){
			this.opcion_w=100;
			this.opcion_h=50;
			this.coordenadas_opciones=repartir_elementos(x+w/2,y+h-h/3,2,2,this.opcion_w,this.opcion_h,50);
			this.texto_opciones=new Array();
			this.texto_opciones[0]="Reservar";
			this.texto_opciones[1]="Cancelar";
			var hora_ini_dialogo=horario.hora_inicio_destacada+horario.hora_inicial;
			var hora_fin_dialogo=horario.hora_fin_destacada+horario.hora_inicial;
			this.texto=new Texto("Se reservaran las horas de ensayo "+hora_ini_dialogo+"-"+hora_fin_dialogo+". Es correcto?",x+100,y+25,w-150,30,AL_IZQ);
		}else if(tag==TAG_SELECCIONAR_BANDA){
			this.opcion_w=75;
			this.opcion_h=25;
			this.coordenadas_opciones=repartir_elementos(x+w/2,y+h-h/4,1,2,this.opcion_w,this.opcion_h,50);
			this.texto_opciones=new Array();
			this.texto_opciones[0]="Cancelar";
			this.texto=new Texto("Selecciona una banda",x+50,y+20,75,20,AL_CEN);
		}
		
		this.destacar_opciones=function(x,y){
			this.opcion_apuntada=-1;
			var i;
			for(i=0;i<this.coordenadas_opciones.length && this.opcion_apuntada==-1;i++){
				var x1=this.coordenadas_opciones[i][0];
				var y1=this.coordenadas_opciones[i][1];
				var x2=x1+this.opcion_w;
				var y2=y1+this.opcion_h;

				if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
					this.opcion_apuntada=i;
			}
		}
	}	
}