/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mousedown', mouse_down, false);
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	
	down=0;
	down_time=0;
	
	//Inicializamos el escenario
	grid=new Grid();
	
	//Inicializamos el horario
	horario=new Horario();
	
	//Inicializamos los botones
	boton_volver=new Boton("boton_volver",25,10,30,30);
	
	//Inicializamos el dialogo
	dialogo=new Dialogo(0,0,0,0,-1);
	
	//Inicializamos los colores
	colores=new Array(7);
	colores[0]=new Array(2);
	colores[0][0]="#FFFFFF";
	colores[0][1]="#EEEEEE";
	colores[1]=new Array(2);
	colores[1][0]="#FF0000";
	colores[1][1]="#EE0000";
	colores[2]=new Array(2);
	colores[2][0]="#00FF00";
	colores[2][1]="#00EE00";
	colores[3]=new Array(2);
	colores[3][0]="#0000FF";
	colores[3][1]="#0000EE";
	colores[4]=new Array(2);
	colores[4][0]="#FFFF00";
	colores[4][1]="#EEEE00";
	colores[5]=new Array(2);
	colores[5][0]="#FF00FF";
	colores[5][1]="#EE00EE";
	colores[6]=new Array(2);
	colores[6][0]="#00FFFF";
	colores[6][1]="#00EEEE";
	
	//Progreso de la carga
	var total=2;
	trozo=100/total;
	progreso=1;
	
	boton_volver.image.onload=function(){progreso+=trozo;};
	boton_volver.over_image.onload=function(){progreso+=trozo;};
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();	
}

function run(){
	animar();
	dibujar();
}

function animar(){	
}

function dibujar() {

	if(progreso<100){
		draw_progressbar(progreso);
	}else{
		//Dibujamos el fondo
		dibujar_fondo();
		
		//Dibujamos el horario
		dibujar_horario();
		
		//Dibujamos los botones
		dibujar_botones();
		
		//Dibujamos el dialogo
		dibujar_dialogo();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
		
		if(fadein_alpha>0){
			dibujar_horario(-1,-1);
			draw_fadein();
		}
		draw_fadeout();
	}
}

function banda_en_medio(h1,h2){
	var existe=0;
	var i;
	/*for(i=h1;i<=h2 && !existe;i++)
		if(horario.celdas[i]*/
	return existe;
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_banda.style.display="block";
		document.formulario.texto_user.style.display="block";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_banda.style.display="none";
		document.formulario.texto_user.style.display="none";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function lanzar_dialogo(x,y,w,h,tag){
	dialogo=new Dialogo(x,y,w,h,tag);
	//grid.mark_grid(6,1,GRID_COLUMNS-1,5);
}



function bloquear(){blok=1;}
function desbloquear(){blok=0;}
