/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");	
	
	cambio=0; //Contador que controla el cambio de fotograma
	fotograma=0; //Numero de fotograma a dibujars
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	down=0;
	down_time=0;
	
	//Inicializamos el jugador
	jugador=new Jugador();
	//Inicializamos el escenario
	escenario=new Escenario();
	//Inicializamos el grid
	grid=new Grid();
	
	jugador.x=Math.round(escenario.xini);
	jugador.y=Math.round(escenario.yini);
	ruta=new Ruta(jugador.getX(),jugador.getY(),jugador.getX(),jugador.getY(),0,0);
	
	tag_destacado=-1;
	objeto_destacado=-1;
	
	
	//Bocadillos
	bocadillos=new Array(1);
	bocadillos[0]=new Bocadillo("contestador",44,8,60,50);
	
	cerrar_destacado=-1;
	contexto.lineWidth = 2; //Grosor
	
	//Creamos el menu
	menu=new Menu(50,50,TAG_ROOM);
	menu_button_pointed=-1;
	
	//Inicializamos el chooser
	chooser=new Chooser(0,0,0,0,-1);
	
	//Inicializamos el dialogo
	dialogo=new Dialogo(0,0,0,0,-1);
	
	//Inicializamos el sobre de las peticiones
	band_requests=new BandRequests(105,20);
	concert_requests=new ConcertRequests(105,20);
	boton_destacado=-1;
	
	//Progreso de la carga
	total=6+jugador.cuerpo_img.length+bocadillos.length+menu.botones.length*2;
	for(i=0;i<escenario.objetos.length;i++)
		for(j=0;j<escenario.objetos[i].length;j++)
			total++;
	trozo=100/total;
	progreso=1;
	jugador.cara_img.onload = function() {progreso+=trozo;}
	jugador.rastro_img.onload = function() {progreso+=trozo;}
	jugador.sombra_img.onload = function() {progreso+=trozo;}
	escenario.fondo_img.onload = function() {
		progreso+=trozo;
		tam_image_square_x=parseInt(escenario.fondo_img.width/GRID_COLUMNS);
		tam_image_square_y=parseInt(escenario.fondo_img.height/GRID_ROWS);
	}
	jugador.cuerpo_img[0].onload = function() {progreso+=trozo;}	
	for(i=0;i<escenario.objetos.length;i++)	for(j=0;j<escenario.objetos[i].length;j++)
			escenario.objetos[i][j].objeto_img.onload = function() {progreso+=trozo;}
	for(i=0;i<bocadillos.length;i++) bocadillos[i].bocadillo_img.onload = function() {progreso+=trozo;}
	for(i=0;i<menu.botones.length;i++){
		menu.botones[i].image.onload = function() {progreso+=trozo;}
		menu.botones[i].over_image.onload = function() {progreso+=trozo;}
	}
	band_requests.boton.image.onload = function() {progreso+=trozo;}
	band_requests.boton.over_image.onload = function() {progreso+=trozo;}
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();
}

function run(){
	animar();
	dibujar();
}

function animar(){
	//Calculamos la escala el personaje
	jugador.escala=jugador.y/ALTURA_EFECTIVA+0.5;
	//Animamos al personaje
	if(jugador.direccion_x==1)
		if(jugador.getX()>ruta.getX())
			jugador.x-=MAX_VELOCIDAD;
		else
			jugador.direccion_x=0;
	else if(jugador.direccion_x==2)
		if(jugador.getX()<ruta.getX())
			jugador.x+=MAX_VELOCIDAD;
		else
			jugador.direccion_x=0;
			
	if(jugador.direccion_y==1)
		if(jugador.getY()>ruta.getY())
			jugador.y-=MAX_VELOCIDAD;
		else
			jugador.direccion_y=0;			
	else if(jugador.direccion_y==2)
		if(jugador.getY()<ruta.getY())
			jugador.y+=MAX_VELOCIDAD;
		else
			jugador.direccion_y=0;
			
	//grid.mark_grid(3,0,GRID_COLUMNS-3,GRID_ROWS-1);
	//grid.clean_grid_area(jugador.x,jugador.y,jugador.x+jugador.cuerpo_w*jugador.escala,jugador.y+jugador.cuerpo_h*jugador.escala);
	
	//Calculamos el fotograma
	if(jugador.direccion_x!=0 || jugador.direccion_y!=0){ //Se esta moviendo
		if(cambio<=0){
			fotograma=(fotograma+1)%(jugador.cuerpo_img.length);
			cambio=MAX_CAMBIO_FOTOGRAMA;
		}else{
			cambio-=INTERVALO_REFRESCAR_PANTALLA;
		}		
	}else{
		if(ruta.finalizada()){
			cambio=0;
			fotograma=0;
		}
	}
	
	//Menu
	if(menu.estado==DESPLEGAR_MENU){
        if(menu.y<MAX_MENU_HIGHT)   menu.y++;
    }else if(menu.estado==REPLEGAR_MENU){
        if(menu.y>0){
            menu.y--;
        }else{
            menu.estado=MENU_INACTIVO;
			//Marcamos las casillas para no redibujarlas
			dibujar_fondo();
        }
    }
	
	//Time the mouse is pressed
	if(down && down_time<MAX_DOWN_TIME){
		down_time++;
	}
}

function dibujar() {

	if(progreso<100){
		draw_progressbar(progreso);
	}else{

		dibujar_fondo();
			
		//Controlamos si el jugador esta pasando por delante o por detras de un objeto
		dibujar_sobre(); //Dibujamos el sobre si hay peticiones
		dibujar_objetos_detras(); //Dibujamos los objetos que se encuentran detras del personaje
		dibujar_rastro(); //dibujamos, si procede, el rastro del personaje
		dibujar_jugador(); //pintamos el jugador			
		dibujar_objetos_delante(); //Dibujamos los objetos que se encuentran delante del personaje
		
		dibujar_bocadillos(); //Dibujamos los bocadillos activos
		dibujar_chooser();
		dibujar_dialogo();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
			
		dibujar_menu();	
		draw_fadein();
		draw_fadeout();
	}
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_area.style.visibility="visible";
		document.formulario.texto_direccion.style.visibility="visible";
		document.formulario.texto_xpos.style.visibility="visible";
		document.formulario.texto_ypos.style.visibility="visible";
		document.formulario.texto_xdest.style.visibility="visible";
		document.formulario.texto_ydest.style.visibility="visible";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_area.style.visibility="hidden";
		document.formulario.texto_direccion.style.visibility="hidden";
		document.formulario.texto_xpos.style.visibility="hidden";
		document.formulario.texto_ypos.style.visibility="hidden";
		document.formulario.texto_xdest.style.visibility="hidden";
		document.formulario.texto_ydest.style.visibility="hidden";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function calcular_area(x){
	var a=escenario.area.length-1; //Area en el que estamos
	
	while(a>0 && x<escenario.area[a][0])
		a--;
		
	return a;
}

function destacar_objeto(x,y){
	var i;
	tag_destacado=-1;
	objeto_destacado=-1;
	for(i=0;i<escenario.objetos.length && objeto_destacado==-1;i++){
		for(j=0;j<escenario.objetos[i].length;j++){
			if(i!=TAG_GUITAR || j==escenario.guitarra_activa){
				var x1=escenario.objetos[i][j].x;
				var y1=escenario.objetos[i][j].y;
				var x2=escenario.objetos[i][j].x+escenario.objetos[i][j].width*escenario.objetos[i][j].escala;
				var y2=escenario.objetos[i][j].y+escenario.objetos[i][j].height*escenario.objetos[i][j].escala;
				
				if(x>=x1 && x<=x2 && y>=y1 && y<=y2){
					tag_destacado=i;
					objeto_destacado=j;
				}
			}
		}
	}
}

function jugador_detras_objeto(objeto){
	return jugador.getY()<objeto.y+objeto.height*objeto.escala;
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}

function lanzar_chooser(x,y,tag){
	chooser=new Chooser(x,y,350,200,tag);
	grid.mark_grid_area(chooser.x,chooser.y,chooser.x+chooser.w,chooser.y+chooser.h);
}

function lanzar_dialogo(x,y,tag){
	dialogo=new Dialogo(x,y,300,200,tag);
	//grid.mark_grid(6,1,GRID_COLUMNS-1,5);
}
